#include <stdlib.h>
#include <stdio.h>

#include "list_utils.h"

#define VERB 0

Nodo* merge(Nodo* l1,Nodo* l2)
{	
	if(VERB){p("merge(): begin l1=");pl(l1);p(" l2=");pln(l2);}

	if(l1==NULL)
	{
		if(VERB){p("merge(): end res=");pln(l2);}
		return l2;
	}
	else if(l2==NULL)
	{
		if(VERB){p("merge(): end res=");pln(l1);}
		return l1;
	}
	
	//l1 !=null && l2!=null
	Nodo* i=l1, *j=l2, *min=NULL;
	Nodo* first=NULL, *last=NULL; //lista risultante
	
	if(VERB){p("merge(): entering loop..\n");}
	
	do
	{
		if(i->dato <= j->dato)
			min=i;
		else
			min=j;
		
		if(first==NULL)
		{ //e' il primo nodo aggiunto in output
			first=min;
		}
		else
		{ //non e' il primo 
			//first non si cambia !!
			last->succ=min;
		}
		
		//in ogni caso
		//incr il puntatore
		if(min ==i)
			i=i->succ;
		else
			j=j->succ;
		
		min->succ=NULL;
		last=min;
	}
	while(i!=NULL && j!=NULL);
	
	if(VERB){p("merge(): exit loop\n");}
	
	//. copia tutti gli elementi rimanenti di L1
	if(i!=NULL)
		last->succ=i;
	
	//. copia tutti gli elementi rimanenti di L2
	if(j!=NULL)
		last->succ=j;
	
	if(VERB){p("merge(): end res=");pln(first);}
	
	return first;
}

//divide la list L a meta' restituendo un puntatore al primo nodo della seconda meta'.
Nodo* split(Nodo* l)
{
	if(VERB){p("split(): begin l=");pln(l);}

	if(l==NULL || l->succ==NULL)
	{
		if(VERB){p("split(): end l=");pln(NULL);}
		return NULL;
	}
	
	//. calc lungh della lista
	int size=0;
	Nodo* curr=l;
	while(curr!=NULL)
	{
		size++;
		curr=curr->succ;
	}
	
	//. trova il predecessore dell'elemento in pos size/2
	Nodo* res=NULL;
	
	int mid_pred=size/2 -1; // size>=2 => mid >=0
	curr=l;
	int curr_idx=0;
	while(curr!=NULL)
	{
		if(curr_idx==mid_pred)
		{
			Nodo* res=curr->succ;
			curr->succ=NULL; //spezza la lista
			
			if(VERB){p("split(): end fstHalf=");pl(l);p(" sndHalf=");pln(res);}
			return res;
		}
		
		curr_idx++;
		curr=curr->succ;
	}
	
	if(VERB){p("split(): end fstHalf=");pl(l);p(" sndHalf=");pln(res);}
	return res;
}

Nodo* list_mergesort(Nodo* l)
{
	if(VERB){p("ms(): begin l=");pln(l);}

	//len==0 || len==1
	if(l==NULL || l->succ==NULL)
	{
		if(VERB){p("ms(): end l=");pln(l);}
		return l;
	}
	
	//1. spezza la lista
	Nodo* snd_half =split(l);
	//2. sort della prima meta'
	l=list_mergesort(l);
	//3. sort della seconda meta'
	snd_half=list_mergesort(snd_half);
	//4. merge delle 2 meta' ordinate
	Nodo* res=merge(l,snd_half);
	
	if(VERB){p("ms(): end l=");pln(res);}
	return res;
}

int main()
{
	printf("list_mergesort : begin\n\n");
	
	int a[]={10,3,15,2,1,4,9,0,0,10};
	
	Nodo* l=make_list(a,0,10);
	print_list(l);
	Nodo* res=list_mergesort(l);
	print_list(res);
	
	return 0;
}
