#include <stdlib.h>
#include <stdio.h>

#include "list_utils.h"

#define VERB 0

void append(Nodo** fst,Nodo** last,Nodo* u)
{
	if(*fst==NULL)
	{	//primo nodo in output
		*fst=u;
		*last=u;
		u->succ=NULL;
	}
	else
	{	//non e' il primo nodo in output
		//fst non cambia
		(*last)->succ=u;
		u->succ=NULL;
		*last=u;
	}
}

/** Sceglie sempre il primo elemento della lista come pivot. Assume che out_l !=NULL.
*RETURNS: out_l e' modificato nel puntatore al primo nodo della lista contenenete i valori <=pivot .
*	Restituisce il puntatore al primo nodo della lista dei valori >pivot.
**/
Nodo* partition(Nodo** out_l)
{
	Nodo* l= *out_l; //puntatore al primo nodo della lista

	if(VERB){p("part(): begin l=");pln(l);}
	
	if(l==NULL || l->succ==NULL) //out_l=[] opp out_l=[x]
	{
		//out_l non e' modificato
		if(VERB){p("part(): end fst_half=");pl(NULL);p(" snd_half=");pln(*out_l);}
		return NULL;
	}
	
	//out_l contiene almeno 2 ints
	int pivot=l->dato;
	Nodo* fst_half=NULL, *fst_half_last=NULL, *snd_half=NULL, *snd_half_last=NULL;
	Nodo* curr=l, *succ=NULL; // il primo nodo e' il pivot !!
	while(curr!=NULL)
	{
		//salva il successore del nodo corrente
		succ=curr->succ;
		
		if(curr->dato <=pivot)
		{	//agigungi in coda a fst_half 	
			append(&fst_half,&fst_half_last,curr);
		}
		else
		{	//agigungi in coda a snd_half
			append(&snd_half,&snd_half_last,curr);
		}
		
		//usa il valore salvato del successore
		curr=succ;
	}
	
	//non sposto il pivot
	
	*out_l=fst_half; //setta out_l
	if(VERB){p("part(): end fst_half=");pl(*out_l);p(" snd_half=");pln(snd_half);}
	return snd_half;
}

void list_quicksort_aux(Nodo* l,Nodo** out_fst,Nodo** out_last)
{
	if(VERB){p("quicksort(): begin l=");pln(l);}

	if(l==NULL)
	{
		if(VERB){p("quicksort(): end\n");}
		return;
	}
	else if(l->succ ==NULL)
	{
		append(out_fst,out_last,l);
		if(VERB){p("quicksort(): end\n");}
		return;
	}
	
	//la lista in input contiene almeno 2 ints
	Nodo* snd_half=partition(&l);
	Nodo* pivot=l; //ista in input contiene almeno 2 ints => L !=NULL
	//rimuove il pivot dalla prima meta'
	l=l->succ;	
	list_quicksort_aux(l,out_fst,out_last);
	append(out_fst,out_last,pivot);
	list_quicksort_aux(snd_half,out_fst,out_last);
	
	if(VERB){p("quicksort(): end\n");}
}

Nodo* list_quicksort(Nodo* l)
{	
	Nodo* out_fst=NULL, *out_last=NULL;
	list_quicksort_aux(l,&out_fst,&out_last);
	
	return out_fst;
}

int main()
{
	printf("list_quicksort : begin\n\n");

	int a[]={10,3,15,2,1,4,9,0,0,10};
	
	Nodo* l=make_list(a,0,10);
	print_list(l);
	Nodo* res=list_quicksort(l);
	print_list(res);
	
	return 0;
}
