#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>

#include "list.h"
#include "list_utils.h"

void p(const char *format, ...)
{
	va_list ap;
	va_start (ap, format);
	vprintf(format, ap);
	va_end (ap);
	fflush(stdout);
}

void pl(Nodo* u)
{
	char* list_str=to_string(u);
	printf(list_str);
	fflush(stdout);

	free(list_str);
}

void pln(Nodo* u)
{
	char* list_str=to_string(u);
	printf("%s\n",list_str);
	fflush(stdout);

	free(list_str);
}

Nodo* make_list(int a[],int from,int len)
{
	Nodo* first=NULL;
	Nodo* last=NULL;
	Nodo* curr=NULL;
	
	int i;
	int max=from+len-1;
	for(i=from;i <=max;i++)
	{
		curr=malloc(sizeof(Nodo));
		curr->dato=a[i];
		curr->succ=NULL;
		
		if(first==NULL)
			first=curr;
		else
			last->succ=curr;
		
		last=curr;
	}
	
	return first;
}

void print_list(Nodo* u)
{
	if(u==NULL)
	{
		printf("[]\n");
		return;
	}
	
	Nodo* curr=u;
	printf("[");
	while(curr!=NULL)
	{	
		if(curr->succ==NULL)
			printf("%d",curr->dato);
		else
			printf("%d,",curr->dato);
		
		curr=curr->succ;
	}
	
	printf("]\n");
}

int size(Nodo* u)
{
	if(u==NULL)
		return 0;
	
	Nodo* curr=u;
	int size=0;
	while(curr!=NULL)
	{
		size++;
		curr=curr->succ;
	}
	
	return size;
}

//versione NAIVE!!
char* to_string(Nodo* u)
{	
	char buff[32];

	int len=size(u);
	int str_size=len*32 +len +2;
	char* res=calloc(str_size,sizeof(char));
	
	strcat(res,"[");
	
	Nodo* curr=u;
	while(curr!=NULL)
	{
		sprintf(buff,"%d",curr->dato);
		strcat(res,buff);
		
		if(curr->succ !=NULL)
		{ //not the last node
			strcat(res,",");
		}
		
		curr=curr->succ;
	}
	
	strcat(res,"]");
	
	return res;
}

int to_array(Nodo* u,int** out)
{
	int len=size(u);
	int* array=malloc(len*sizeof(int));
	
	Nodo* curr=u;
	int idx=0;
	while(curr!=NULL)
	{
		array[idx]=curr->dato;
	
		idx++;
		curr=curr->succ;
	}
	
	*out=array;
	return len;
}
